<?php

    // Gestion des catalogues ================================= 

    // Get all catalogues
    $app->get('/catalogues', function () use ($app) {$app->sendAll("catalogue");});

    // Get all categories
    $app->get('/categories', function () use ($app) {$app->sendAll("category");});

    // lib json
    $app->get('/catalogue/:id/json', function ($id) use ($app) {
        $catalogue = $app->mustExistAndVisible("catalogue",$id);
        echo json_encode($catalogue->json());
    });

    // Edit catalogue
    $app->get('/catalogue/:id', function ($id) use ($app) {
        $catalogue = $app->createIfNotExist("catalogue",$id);
        $app->render('catalogue-edit.php', array('catalogue' => $catalogue));
    });

    // Get catalogue ressources
    $app->get('/catalogue/ressources/:id', function ($id) use ($app) {

        $catalogue = $app->mustExistAndVisible("catalogue",$id);
        
        // Liste les catalogues visibles
        $a=array();
        foreach ($catalogue->ownRessource as $ressource) 
        {
            if ($ressource->isVisible()) $a[]=$ressource->json();    
        }
        $app->outputArray($a); 

    });

    // Delete catalogue
    $app->delete('/catalogue/:id', function ($id) use ($app) {
        $catalogue = $app->mustExistAndDeletable("catalogue",$id);
        R::trash( $catalogue );      
    });

    // Sauvegarde 
    $app->post('/catalogue/:id', function ($id) use ($app) {

        $catalogue = R::findOne('catalogue', 'id = ?',array($id));
        if (! $catalogue ) {  $catalogue=R::dispense('catalogue');}

        if (!$catalogue->isEditable()) return;
        
        $req = $app->request();
        $catalogue->name=$req->post("name");
        $catalogue->sharedContext=$app->getContexts($req->post("context"));
        $catalogue->description=$req->post("description");   
        $catalogue->autorisations=$req->post("autorisations");    
        R::store($catalogue);         

    });

    // ========================================================

?>
